Subject: Re: [PATCH 1/2] pkt_sched: Fix gen_estimator locks

From: Jarek Poplawski <[email-masked]>
Date: Wed, 27 Aug 2008 11:22:45 +0000

On Wed, Aug 27, 2008 at 04:15:11AM -0700, David Miller wrote:
> From: Jarek Poplawski <[email-masked]>
> Date: Wed, 27 Aug 2008 11:09:39 +0000
> 
> > On Wed, Aug 27, 2008 at 03:47:23AM -0700, David Miller wrote:
> > > From: Jarek Poplawski <[email-masked]>
> > > Date: Wed, 27 Aug 2008 10:44:58 +0000
> > > 
> > > > Yes, it should be simpler. (We can probably consider a pointer to
> > > > itself instead of NULL for root qdiscs, to skip testing for NULL e.g.
> > > > while getting a lock.) On the other hand, we lose with this the
> > > > possibility to easily determine which dev_queue is "the owner" of the
> > > > qdisc, or if some dev_queue contains a clone only.
> > > 
> > > For root qdiscs we can add a TCQ_F_SHARED flag for this purpose.
> > 
> > Yes, but we can't do something like this:
> 
> Good point.
> 
> We could go back to using a device scope list.  The only piece to
> solve at that point is how to differentiate the different entries in
> the non-shared multiq case.
> 
> What it comes down to is semantics, and how we might want to handle
> multiq non-shared cases in future uses.
> 
> Maybe some day we'll allow real complicated configurations, such as
> mixes of shared and non-shared qdiscs on the TX queues.
> 
> So we'd need to think about how that would look, implementation wise.

On the other hand, we could save this functionality with another flag
e.g.:__QDISC_STATE_CLONED for all dev_queues, except "the owner"?

Jarek P.